#lang racket
;; User data-structure
(define (point x y z)
  (list x y z))

(define (point? p)
  (and
    (list? p)
    (equal? (length p) 3)))

(define (point-x p)
  (first p))

(define (point-y p)
  (second p))

(define (point-z p)
  (third p))


;; TESTS BELOW
(require rackunit)
(define p (point 1 2 3))
(check-equal? (list 1 2 3) p)


(check-true (point? p))
; Is type?
(check-false (point? "foo"))
(check-false (point? (list)))
(check-false (point? '()))
; Accessors
(check-equal? 1 (point-x p))
(check-equal? 2 (point-y p))
(check-equal? 3 (point-z p))
